using System;
using System.Collections.Generic;

namespace EnumsToStringCached
{
    public static class EnumExtensions
    {
        private static Dictionary<Enum, string> enumStringValues = new Dictionary<Enum, string>();
        public static string ToStringCached(this Enum myEnum)
        {   
            string textValue;
            if (enumStringValues.TryGetValue(myEnum, out textValue))
            {
                return textValue;
            }
            else
            {
                textValue = myEnum.ToString();
                enumStringValues[myEnum] = textValue;
                return textValue;
            }
        }
    }
}